import { toList } from './utils.js'

/**
 * @template L, R
 * @typedef {Left<L> | Right<R>} Either
 */

/**
 * @template T
 * @constructor
 * @param {T} value
 */
export const Left = value => ({
    ...Monad(Left, value),
    bind: _f => Left(value),
    map: _f => Left(value),
    isLeft: () => true,
    isRight: () => false,
    ...Tag('Left', toList(value))
})

/**
 * @template T
 * @constructor
 * @param {T} value
 */
export const Right = value => ({
    ...Monad(Right, value),
    isLeft: () => false,
    isRight: () => true,
    ...Tag('Right', toList(value))
})

