/**
 * @template M, T
 * @constructor
 * @param {(value: T) => M} lift 
 * @param {T} value
 */
export function Monad(lift, value) {
    const name = lift.name

    return {
        bind: f => f(value),
        map(f) { return lift(this.bind(f)) },
        toString: () => `${name}(${value})`
    }
}


