import { Monad } from './monad.js'
import { Tag } from './union.js'
import { emptyList, toList } from './utils.js'

/**
 * @template T
 * @typedef {Some<T> | None} Option
 */
export const None = Object.freeze({
    bind: _f => None,
    map: _f => None,
    isSome: () => false,
    isNone: () => true,
    ...Tag('None', emptyList),
    toString: () => 'None'
})

/**
 * @template T
 * @constructor
 * @param {T} value
 */
export const Some = value => ({
    ...Monad(Some, value),
    isSome: () => true,
    isNone: () => false,
    ...Tag('Some', toList(value))
})

