import { Monad } from './monad.js'
import { Tag } from './union.js'
import { toList } from './utils.js'

/**
 * @template T, E
 * @typedef {Ok<T> | Err<E>} Result
 */

/**
 * @template T
 * @constructor
 * @param {T} value
 */
export const Err = value => ({
    ...Monad(Err, value),
    bind: _f => Err(value),
    map: _f => Err(value),
    isError: () => true,
    isOk: () => false,
    ...Tag('Err', toList(value))
})

/**
 * @template T
 * @constructor
 * @param {T} value
 */
export const Ok = value => ({
    ...Monad(Ok, value),
    isError: () => false,
    isOk: () => true,
    ...Tag('Ok', toList(value))
})

